#!/bin/bash
#

inv=`tput smso`
nor=`tput rmso`
UPLOAD=/backups/upload
PATCHBASE=/backups/patch

heading() {
 clear
 echo "${inv} Swivel Maintenance (c) 2008${nor}
            ${inv}$PINSAFE_TYPE${nor}"
 echo
 echo $1
 echo
}

s_heading() {
 clear
 echo "${inv} Swivel Maintenance (c) 2008${nor}
            ${inv}$PINSAFE_TYPE${nor}"
 echo
}

yorn() {
 echo
 echo -n "Are you sure? (Yes/No): "
 read yn
 check_ans $1 $yn
}

check_ans() {
 if test ! $2; then
  $1; fi
 if test ! $2 = "Yes" && test ! $2 = "yes" && test ! $2 = "y" && test ! $2 = "Y" ; then
  $1; fi
}

get_patch_ver() {
 PATCH_VER=`cat $PATCHBASE/patch_ver`
 PATCH_VER_ORIG=`grep APPLIANCE_PATCH_VER /etc/pinsafe.conf|cut -d\= -f2`
 patch_ver_new=`echo $PATCH_VER|cut -d\. -f3`
 patch_ver_existing=`grep APPLIANCE_PATCH_VER /etc/pinsafe.conf|cut -d\. -f3`
}

update_patch_ver() {
 sed -i "s/APPLIANCE_PATCH_VER=$PATCH_VER_ORIG/APPLIANCE_PATCH_VER=$PATCH_VER/g" /etc/pinsafe.conf
}

test_patch_ver(){
 p1=`expr $patch_ver_existing + 2`

 if test $patch_ver_new -le $patch_ver_existing; then
  echo "This patch has already been applied."
  echo
  echo "   Current patch level of appliance: $PATCH_VER_ORIG"
  echo "   Patch version: $PATCH_VER"
  echo
  read -p "Press Return to exit"
  exit; fi

 if test $p1 -gt $patch_ver_new; then
  echo "The applaince patch version is newer than the patch you are trying to apply."
  echo
  echo "   Current patch level of appliance: $PATCH_VER_ORIG"
  echo "   Patch version: $PATCH_VER"
  echo
  read -p "Press Return to exit"
  exit; fi

 if test $p1 -lt $patch_ver_new; then
  echo "Please apply the previous patches before applying this patch. Existing patch"
  echo "level is too low:"
  echo
  echo "   Current patch level of appliance: $PATCH_VER_ORIG"
  echo "   Patch version: $PATCH_VER"
  echo
  read -p "Press Return to exit"
  exit; fi
}

# Create update routine. Use Standard calls above.

commands() {
 heading "Applying Patch"
 get_patch_ver
 test_patch_ver
 stuff
 update_patch_ver
}

update_pinsafe_conf() {
 cat $PATCHBASE/pinsafe.conf.minimal > /tmp/pinsafe.conf.$$
 grep "^archives=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^DRBD=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^logs=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^PINSAFE_TYPE=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^DR=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^ActiveIP=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^REP_INTERF=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^NTP_SERVER=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^SMTP=" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
 grep "^FTP_" /etc/pinsafe.conf >> /tmp/pinsafe.conf.$$
}

stuff() {
cd $PATCHBASE
./update_now.sh
}

commands
echo; read -p "Press Return to continue" yn
